require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_STDINT_H_)) {
    eval 'sub _SYS_STDINT_H_ () {1;}' unless defined(&_SYS_STDINT_H_);
    require 'sys/cdefs.ph';
    require 'machine/int_types.ph';
    unless(defined(&int8_t)) {
	eval 'sub int8_t () { &__int8_t;}' unless defined(&int8_t);
    }
    unless(defined(&uint8_t)) {
	eval 'sub uint8_t () { &__uint8_t;}' unless defined(&uint8_t);
    }
    unless(defined(&int16_t)) {
	eval 'sub int16_t () { &__int16_t;}' unless defined(&int16_t);
    }
    unless(defined(&uint16_t)) {
	eval 'sub uint16_t () { &__uint16_t;}' unless defined(&uint16_t);
    }
    unless(defined(&int32_t)) {
	eval 'sub int32_t () { &__int32_t;}' unless defined(&int32_t);
    }
    unless(defined(&uint32_t)) {
	eval 'sub uint32_t () { &__uint32_t;}' unless defined(&uint32_t);
    }
    unless(defined(&int64_t)) {
	eval 'sub int64_t () { &__int64_t;}' unless defined(&int64_t);
    }
    unless(defined(&uint64_t)) {
	eval 'sub uint64_t () { &__uint64_t;}' unless defined(&uint64_t);
    }
    unless(defined(&intptr_t)) {
	eval 'sub intptr_t () { &__intptr_t;}' unless defined(&intptr_t);
    }
    unless(defined(&uintptr_t)) {
	eval 'sub uintptr_t () { &__uintptr_t;}' unless defined(&uintptr_t);
    }
    require 'machine/int_mwgwtypes.ph';
    if(!defined(&__cplusplus) || defined(&__STDC_LIMIT_MACROS) || ((defined(&__cplusplus) ? &__cplusplus : undef) >= 201103)) {
	require 'machine/int_limits.ph';
    }
    if(!defined(&__cplusplus) || defined(&__STDC_CONSTANT_MACROS) || ((defined(&__cplusplus) ? &__cplusplus : undef) >= 201103)) {
	require 'machine/int_const.ph';
    }
    require 'machine/wchar_limits.ph';
}
1;
