require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_PMAP_H_)) {
    eval 'sub _X86_PMAP_H_ () {1;}' unless defined(&_X86_PMAP_H_);
    eval 'sub pl1_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L1_MASK) >>  &L1_SHIFT));
    }' unless defined(&pl1_pi);
    eval 'sub pl2_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L2_MASK) >>  &L2_SHIFT));
    }' unless defined(&pl2_pi);
    eval 'sub pl3_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L3_MASK) >>  &L3_SHIFT));
    }' unless defined(&pl3_pi);
    eval 'sub pl4_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L4_MASK) >>  &L4_SHIFT));
    }' unless defined(&pl4_pi);
    eval 'sub pl1_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L1_FRAME) >>  &L1_SHIFT));
    }' unless defined(&pl1_i);
    eval 'sub pl2_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L2_FRAME) >>  &L2_SHIFT));
    }' unless defined(&pl2_i);
    eval 'sub pl3_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L3_FRAME) >>  &L3_SHIFT));
    }' unless defined(&pl3_i);
    eval 'sub pl4_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L4_FRAME) >>  &L4_SHIFT));
    }' unless defined(&pl4_i);
    eval 'sub pl_i {
        my($va, $lvl) = @_;
	    eval q(((( &VA_SIGN_POS($va)) &  $ptp_masks[($lvl)-1]) >>  $ptp_shifts[($lvl)-1]));
    }' unless defined(&pl_i);
    eval 'sub pl_i_roundup {
        my($va, $lvl) = @_;
	    eval q( &pl_i(($va)+ ~ $ptp_masks[($lvl)-1], ($lvl)));
    }' unless defined(&pl_i_roundup);
    eval 'sub ptp_va2o {
        my($va, $lvl) = @_;
	    eval q(( &pl_i($va, ($lvl)+1) *  &PAGE_SIZE));
    }' unless defined(&ptp_va2o);
    if(defined(&PAE)) {
	eval 'sub PDP_SIZE () {4;}' unless defined(&PDP_SIZE);
    } else {
	eval 'sub PDP_SIZE () {1;}' unless defined(&PDP_SIZE);
    }
    if(defined(&_KERNEL)) {
	require 'sys/kcpuset.ph';
	require 'uvm/pmap/pmap_pvt.ph';
	unless(defined(&_MAXGDTSIZ)) {
	    eval 'sub _MAXGDTSIZ () {65536;}' unless defined(&_MAXGDTSIZ);
	}
	if(defined(&SVS)) {
	}
	eval 'sub pm_lock () { ($pm_obj[0]->{vmobjlock});}' unless defined(&pm_lock);
	if(!defined(&__x86_64__)) {
	}
	if(defined(&PAE)) {
	    eval 'sub pmap_pdirpa {
	        my($pmap, $index) = @_;
    		eval q((($pmap)-> $pm_pdirpa[ &l2tol3($index)] +  &l2tol2($index) * $sizeof{ &pd_entry_t}));
	    }' unless defined(&pmap_pdirpa);
	} else {
	    eval 'sub pmap_pdirpa {
	        my($pmap, $index) = @_;
    		eval q((($pmap)-> $pm_pdirpa[0] + ($index) * $sizeof{ &pd_entry_t}));
	    }' unless defined(&pmap_pdirpa);
	}
	eval 'sub pmap_resident_count {
	    my($pmap) = @_;
    	    eval q((($pmap)-> ($pm_stats->{resident_count})));
	}' unless defined(&pmap_resident_count);
	eval 'sub pmap_wired_count {
	    my($pmap) = @_;
    	    eval q((($pmap)-> ($pm_stats->{wired_count})));
	}' unless defined(&pmap_wired_count);
	eval 'sub pmap_clear_modify {
	    my($pg) = @_;
    	    eval q( &pmap_clear_attrs($pg,  &PG_M));
	}' unless defined(&pmap_clear_modify);
	eval 'sub pmap_clear_reference {
	    my($pg) = @_;
    	    eval q( &pmap_clear_attrs($pg,  &PG_U));
	}' unless defined(&pmap_clear_reference);
	eval 'sub pmap_copy {
	    my($DP,$SP,$D,$L,$S) = @_;
    	    eval q( &__USE($L));
	}' unless defined(&pmap_copy);
	eval 'sub pmap_is_modified {
	    my($pg) = @_;
    	    eval q( &pmap_test_attrs($pg,  &PG_M));
	}' unless defined(&pmap_is_modified);
	eval 'sub pmap_is_referenced {
	    my($pg) = @_;
    	    eval q( &pmap_test_attrs($pg,  &PG_U));
	}' unless defined(&pmap_is_referenced);
	eval 'sub pmap_move {
	    my($DP,$SP,$D,$L,$S) = @_;
    	    eval q();
	}' unless defined(&pmap_move);
	eval 'sub pmap_phys_address {
	    my($ppn) = @_;
    	    eval q(( &x86_ptob($ppn) & ~ &X86_MMAP_FLAG_MASK));
	}' unless defined(&pmap_phys_address);
	eval 'sub pmap_mmap_flags {
	    my($ppn) = @_;
    	    eval q( &x86_mmap_flags($ppn));
	}' unless defined(&pmap_mmap_flags);
	eval 'sub pmap_valid_entry {
	    my($E) = @_;
    	    eval q((($E) &  &PG_V));
	}' unless defined(&pmap_valid_entry);
	if(defined(&__x86_64__) || defined(&PAE)) {
	    eval 'sub X86_MMAP_FLAG_SHIFT () {(64-  &PGSHIFT);}' unless defined(&X86_MMAP_FLAG_SHIFT);
	} else {
	    eval 'sub X86_MMAP_FLAG_SHIFT () {(32-  &PGSHIFT);}' unless defined(&X86_MMAP_FLAG_SHIFT);
	}
	eval 'sub X86_MMAP_FLAG_MASK () {0xf;}' unless defined(&X86_MMAP_FLAG_MASK);
	eval 'sub X86_MMAP_FLAG_PREFETCH () {0x1;}' unless defined(&X86_MMAP_FLAG_PREFETCH);
	eval 'sub __HAVE_PMAP_PV_TRACK () {1;}' unless defined(&__HAVE_PMAP_PV_TRACK);
	unless(defined(&__HAVE_DIRECT_MAP)) {
	}
	eval("sub TLBSHOOT_APTE () { 0; }") unless defined(&TLBSHOOT_APTE);
	eval("sub TLBSHOOT_KENTER () { 1; }") unless defined(&TLBSHOOT_KENTER);
	eval("sub TLBSHOOT_KREMOVE () { 2; }") unless defined(&TLBSHOOT_KREMOVE);
	eval("sub TLBSHOOT_FREE_PTP1 () { 3; }") unless defined(&TLBSHOOT_FREE_PTP1);
	eval("sub TLBSHOOT_FREE_PTP2 () { 4; }") unless defined(&TLBSHOOT_FREE_PTP2);
	eval("sub TLBSHOOT_REMOVE_PTE () { 5; }") unless defined(&TLBSHOOT_REMOVE_PTE);
	eval("sub TLBSHOOT_REMOVE_PTES () { 6; }") unless defined(&TLBSHOOT_REMOVE_PTES);
	eval("sub TLBSHOOT_SYNC_PV1 () { 7; }") unless defined(&TLBSHOOT_SYNC_PV1);
	eval("sub TLBSHOOT_SYNC_PV2 () { 8; }") unless defined(&TLBSHOOT_SYNC_PV2);
	eval("sub TLBSHOOT_WRITE_PROTECT () { 9; }") unless defined(&TLBSHOOT_WRITE_PROTECT);
	eval("sub TLBSHOOT_ENTER () { 10; }") unless defined(&TLBSHOOT_ENTER);
	eval("sub TLBSHOOT_UPDATE () { 11; }") unless defined(&TLBSHOOT_UPDATE);
	eval("sub TLBSHOOT_BUS_DMA () { 12; }") unless defined(&TLBSHOOT_BUS_DMA);
	eval("sub TLBSHOOT_BUS_SPACE () { 13; }") unless defined(&TLBSHOOT_BUS_SPACE);
	eval("sub TLBSHOOT__MAX () { 14; }") unless defined(&TLBSHOOT__MAX);
	eval 'sub __HAVE_PMAP_EMAP () {1;}' unless defined(&__HAVE_PMAP_EMAP);
	eval 'sub PMAP_GROWKERNEL () {1;}' unless defined(&PMAP_GROWKERNEL);
	eval 'sub PMAP_FORK () {1;}' unless defined(&PMAP_FORK);
	eval 'sub PMAP_PAGEIDLEZERO {
	    my($pa) = @_;
    	    eval q( &pmap_pageidlezero(($pa)));
	}' unless defined(&PMAP_PAGEIDLEZERO);
	require 'lib/libkern/libkern.ph';
	eval 'sub vtopte {
	    my($va) = @_;
    	    eval q({  &KASSERT($va <  &VM_MIN_KERNEL_ADDRESS); ( &PTE_BASE +  &pl1_i($va)); });
	}' unless defined(&vtopte);
	eval 'sub kvtopte {
	    my($va) = @_;
    	    eval q({  &pd_entry_t * &pde;  &KASSERT($va >=  &VM_MIN_KERNEL_ADDRESS);  &pde =  &L2_BASE +  &pl2_i($va);  &if (* &pde &  &PG_PS) (( &pt_entry_t *) &pde); ( &PTE_BASE +  &pl1_i($va)); });
	}' unless defined(&kvtopte);
	if(defined(&XEN)) {
	    require 'sys/bitops.ph';
	    eval 'sub XPTE_MASK () { &L1_FRAME;}' unless defined(&XPTE_MASK);
	    eval 'sub XPTE_SHIFT () {( &L1_SHIFT -  &ilog2($sizeof{ &pt_entry_t}));}' unless defined(&XPTE_SHIFT);
	    eval 'sub XPMAP_UPDATE_DIRECT () {1;}' unless defined(&XPMAP_UPDATE_DIRECT);
	    eval 'sub vtomfn {
	        my($va) = @_;
    		eval q(( &vtomach($va) >>  &PAGE_SHIFT));
	    }' unless defined(&vtomfn);
	}
	eval 'sub POOL_VTOPHYS {
	    my($va) = @_;
    	    eval q( &vtophys(( &vaddr_t) ($va)));
	}' unless defined(&POOL_VTOPHYS);
	if(defined(&__HAVE_PCPU_AREA)) {
	    eval 'sub PDIR_SLOT_PCPU () {384;}' unless defined(&PDIR_SLOT_PCPU);
	    eval 'sub PMAP_PCPU_BASE () {( &VA_SIGN_NEG(( &PDIR_SLOT_PCPU *  &NBPD_L4)));}' unless defined(&PMAP_PCPU_BASE);
	}
	if(defined(&__HAVE_DIRECT_MAP)) {
	    eval 'sub L4_SLOT_DIRECT () {509;}' unless defined(&L4_SLOT_DIRECT);
	    eval 'sub PDIR_SLOT_DIRECT () { &L4_SLOT_DIRECT;}' unless defined(&PDIR_SLOT_DIRECT);
	    eval 'sub PMAP_DIRECT_BASE () {( &VA_SIGN_NEG(( &L4_SLOT_DIRECT *  &NBPD_L4)));}' unless defined(&PMAP_DIRECT_BASE);
	    eval 'sub PMAP_DIRECT_END () {( &VA_SIGN_NEG((( &L4_SLOT_DIRECT + 1) *  &NBPD_L4)));}' unless defined(&PMAP_DIRECT_END);
	    eval 'sub PMAP_DIRECT_MAP {
	        my($pa) = @_;
    		eval q((( &vaddr_t) &PMAP_DIRECT_BASE + ($pa)));
	    }' unless defined(&PMAP_DIRECT_MAP);
	    eval 'sub PMAP_DIRECT_UNMAP {
	        my($va) = @_;
    		eval q((( &paddr_t)($va) -  &PMAP_DIRECT_BASE));
	    }' unless defined(&PMAP_DIRECT_UNMAP);
	    eval 'sub PMAP_MAP_POOLPAGE {
	        my($pa) = @_;
    		eval q( &PMAP_DIRECT_MAP(($pa)));
	    }' unless defined(&PMAP_MAP_POOLPAGE);
	    eval 'sub PMAP_UNMAP_POOLPAGE {
	        my($va) = @_;
    		eval q( &PMAP_DIRECT_UNMAP(($va)));
	    }' unless defined(&PMAP_UNMAP_POOLPAGE);
	}
    }
}
1;
