require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_64_ANSI_H_)) {
    eval 'sub _X86_64_ANSI_H_ () {1;}' unless defined(&_X86_64_ANSI_H_);
    if(defined(&__x86_64__)) {
	require 'sys/cdefs.ph';
	require 'machine/int_types.ph';
	eval 'sub _BSD_CLOCK_T_ () {\'unsigned int\';}' unless defined(&_BSD_CLOCK_T_);
	eval 'sub _BSD_PTRDIFF_T_ () {\'long\';}' unless defined(&_BSD_PTRDIFF_T_);
	eval 'sub _BSD_SIZE_T_ () {\'unsigned long\';}' unless defined(&_BSD_SIZE_T_);
	eval 'sub _BSD_SSIZE_T_ () {\'long\';}' unless defined(&_BSD_SSIZE_T_);
	eval 'sub _BSD_TIME_T_ () { &__int64_t;}' unless defined(&_BSD_TIME_T_);
	eval 'sub _BSD_CLOCKID_T_ () {\'int\';}' unless defined(&_BSD_CLOCKID_T_);
	eval 'sub _BSD_TIMER_T_ () {\'int\';}' unless defined(&_BSD_TIMER_T_);
	eval 'sub _BSD_SUSECONDS_T_ () {\'int\';}' unless defined(&_BSD_SUSECONDS_T_);
	eval 'sub _BSD_USECONDS_T_ () {\'unsigned int\';}' unless defined(&_BSD_USECONDS_T_);
	eval 'sub _BSD_WCHAR_T_ () {\'int\';}' unless defined(&_BSD_WCHAR_T_);
	eval 'sub _BSD_WINT_T_ () {\'int\';}' unless defined(&_BSD_WINT_T_);
    } else {
	require 'i386/ansi.ph';
    }
}
1;
